local ThreatMeter = Apollo.GetAddon("ThreatMeter")
local DaiGUI = Apollo.GetPackage("DaiGUI-1.0").tPackage
local ktFormDefinitions


function ThreatMeter:CreateMainWindow()
  return self:FactoryProduce("MainForm", "FixedHudStratum")
end

function ThreatMeter:CreateWarningWindow()
  return self:FactoryProduce("WarningForm", "FixedHudStratumHigh")
end

function ThreatMeter:CreateOptionsWindow()
  return self:FactoryProduce("OptionsForm")
end

-- Create a list item window
function ThreatMeter:CreateItemWindow()
  return self:FactoryProduce("ListItem", self.wndItemList)
end

function ThreatMeter:FactoryProduce(strFormName, wndParent, tObject)
	local wndNew

  if wndParent ~= nil and type(wndParent) ~= "string" and tObject ~= nil then
    wndNew = wndParent:FindChildByUserData(tObject)
  end

	if not wndNew then
    wndNew = DaiGUI:Create(ktFormDefinitions[strFormName]):GetInstance(self, wndParent)
    wndNew:SetData(tObject)
	end
	return wndNew
end


ktFormDefinitions = {
  --
  WarningForm = {
    AnchorOffsets = { -180, -30, 180, 30 },
    AnchorPoints = "CENTER",
    RelativeToClient = true,
    Name = "ThreatMeterWarningForm",
    SwallowMouseClicks = true,
    Moveable = true,
    Sizable = false,
    Overlapped = true,
    IgnoreMouse = false,
    NewWindowDepth = 1,
    Visible = false,
    Children = {
      {
        AnchorPoints = "FILL",
        RelativeToClient = true,
        Name = "Targeted",
        Pixies = {
          { AnchorPoints = "FILL", BGColor = "white", TextColor = "aaff0000", Font = "CRB_FloaterGigantic_O", Text = "High Threat", DT_CENTER = true, DT_VCENTER = true, },
        },
      },
    },
  },


  --
  ListItem = {
    AnchorOffsets = { 0, 0, 0, 18 },
    AnchorPoints = "HFILL",
    RelativeToClient = true,
    Name = "ListItem",
    SwallowMouseClicks = false,
    Children = {
      {
        AnchorOffsets = { 8, -1, -122, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true,
        Font = "CRB_Interface10_BO",
        Text = "",
        Name = "NameText",
        DT_VCENTER = true,
      },
      {
        AnchorOffsets = { 8, -1, -108, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true,
        Font = "CRB_Interface9_BO",
        Text = "",
        Name = "TpsText",
        DT_VCENTER = true,
        DT_RIGHT = true,
      },
      {
        AnchorOffsets = { 8, -1, -8, 0 },
        AnchorPoints = "FILL",
        RelativeToClient = true,
        Font = "CRB_Interface9_BO",
        Text = "",
        Name = "AmountText",
        DT_VCENTER = true,
        DT_RIGHT = true,
      },
      {
        AnchorOffsets = { 0, 1, 0, 2 },
        AnchorPoints = "FILL",
        Class = "ProgressBar",
        AutoSetText = false,
        UseValues = false,
        RelativeToClient = true,
        SetTextToProgress = true,
        DT_CENTER = true,
        DT_VCENTER = true,
        ProgressEmpty = "ClientSprites:BlackFill",
        ProgressFull = "ClientSprites:HoverHealthFull", -- ClientSprites:WhiteFill",
        Name = "ProgressBar",
        BarColor = "ffffffff",
        IgnoreMouse = true,
        UsePercent = false,
      },
    },
  },


  --
  MainForm = {
    AnchorOffsets = { 4, 4, 404, 196 },
    RelativeToClient = true,
    Name = "MainForm",
    SwallowMouseClicks = true,
    Moveable = true,
--    Escapable = true,
    Overlapped = true,
    Sizable = true,
    Visible = false,
    Pixies = {
      { AnchorPoints = "BOTTOMRIGHT", AnchorOffsets = {-33, -33, -26, -24}, ResizeHandle=5 },

    },
    Children = {
      {
        AnchorOffsets = { 0, 0, -1, -1 },
        AnchorPoints = "FILL",
        RelativeToClient = true,
        Name = "BackgroundArtwork",
         Pixies = {
              { AnchorPoints = "FILL", Name="BackgroundArtwork", Sprite = "BK3:UI_BK3_Holo_Framing_3", BGColor = "white", TextColor = "black"},
        }
      },
      {
        AnchorOffsets = { 36, 25, -51, 51 },
        AnchorPoints = "HFILL",
        RelativeToClient = true,
        Font = "DefaultButton",
        Name = "TitleText",
        TextColor = "UI_TextHoloTitle",
        DT_VCENTER = true,
        NewControlDepth = 2,
        Text = "ThreatMeter",
      },
      {
        AnchorOffsets = { -53, 28, -29, 52 },
        AnchorPoints = "TOPRIGHT",
        Class = "Button",
        Base = "BK3:btnHolo_Close",
        Font = "Thick",
        ButtonType = "PushButton",
        DT_VCENTER = true,
        DT_CENTER = true,
        Name = "CloseButton",
        NewControlDepth = 2,
        WindowSoundTemplate = "CloseWindowPhys",
        Events = {
          ButtonSignal = "OnClose",
        },
      },
      {
        AnchorOffsets = { 31, 51, -33, -32 },
        AnchorPoints = "FILL",
        RelativeToClient = true,
        BGColor = "UI_WindowBGDefault",
        TextColor = "UI_WindowTextDefault",
        Name = "Container",
        IgnoreMouse = true,
        Children = {
          {
            AnchorPoints = "FILL",
            RelativeToClient = true,
            BGColor = "2x:ffffffff",
            TextColor = "UI_WindowTextDefault",
            Name = "ContainerArt",
            IgnoreMouse = true,
            Sprite = "BK3:sprMetal_Scroll_Framing",
            NoClip = true,
            Picture = true,
            Children = {
              {
                AnchorOffsets = { -142, 2, -1, -1 },
                AnchorPoints = "VFILLRIGHT",
                RelativeToClient = true,
                BGColor = "UI_WindowBGDefault",
                TextColor = "UI_WindowTextDefault",
                Name = "Crack",
                Sprite = "BK3:UI_BK3_Holo_Framing_Crack",
                Picture = true,
                IgnoreMouse = true,
              },
              {
                AnchorOffsets = { 2, 2, -2, -2 },
                AnchorPoints = "FILL",
                RelativeToClient = true,
                BGColor = "UI_WindowBGDefault",
                TextColor = "UI_WindowTextDefault",
                Name = "Scanlines",
                Picture = true,
                IgnoreMouse = true,
                Sprite = "CRB_Basekit:kitAccent_Scanlines",
              },
            },
          },
          {
            AnchorOffsets = { 2, 2, -2, -2 },
            AnchorPoints = "FILL",
            RelativeToClient = true,
            Name = "ItemList",
--            VScroll = true,
            IgnoreMouse = true,
          },
        },
      },
    },
  },

  --
  OptionsForm = {
    AnchorOffsets = { -254, -340, 254, 400 },
    AnchorPoints = "CENTER",
    Name = "OptionsForm1",
    SwallowMouseClicks = true,
    Moveable = true,
    Escapable = true,
    Overlapped = true,
    Pixies = {
      { AnchorPoints = "FILL", Sprite = "BK3:UI_BK3_Holo_Framing_2", },
    },
    Children = {
     {
        AnchorOffsets = { -63, 29, -31, 61 },
        AnchorPoints = "TOPRIGHT",
        Class = "Button",
        Base = "BK3:btnHolo_Close",
        Font = "Thick",
        ButtonType = "PushButton",
        DT_VCENTER = true,
        DT_CENTER = true,
        Name = "CloseButton",
        NewControlDepth = 10,
        Events = {
          ButtonSignal = "OnOptionsClose",
        },
      },
      {
        AnchorOffsets = { 60, 68, -60, 340 },
        AnchorPoints = "HFILL",
        Template = "CRB_InnerWindow",
        Name = "GeneralFrame",
        NewControlDepth = 10,
        IgnoreMouse = true,
        Pixies = {
          { AnchorOffsets = { 10, 8, -30, 40 }, AnchorPoints = { 0, 0, 0.5, 0 }, TextColor = "UI_TextHoloBodyHighlight", Font = "CRB_InterfaceMedium", Text = "TPS Window", DT_VCENTER = true, },
          { AnchorOffsets = { 50, 160, 508, 180 }, BGColor = "white", TextColor = "UI_TextHoloBodyHighlight", Font = "CRB_Interface10", Text = "Main Window Opacity %", DT_VCENTER = true, },
          { AnchorOffsets = { 50, 195, 508, 225 }, BGColor = "white", TextColor = "UI_TextHoloBodyHighlight", Font = "CRB_Interface10", Text = "Main Window Artwork %", DT_VCENTER = true, },
        },
        Children = {
					{
						AnchorOffsets = { 10, 114, 0, 138 },
						AnchorPoints = "HFILL",
						Class = "Button",
						Base = "BK3:btnHolo_Check",
						Font = "CRB_InterfaceMedium",
						ButtonType = "Check",
						DT_VCENTER = true,
						Name = "ThreatTotalPrecision",
						TextColor = "UI_WindowTextDefault",
						NormalTextColor = "UI_BtnTextBlueNormal",
						PressedTextColor = "UI_BtnTextBluePressed",
						FlybyTextColor = "UI_BtnTextBlueFlyby",
						PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
						DisabledTextColor = "UI_BtnTextBlueDisabled",
						Text = " Increase threat total precision to 3 decimal places",
						DrawAsCheckbox = true,
						Tooltip = "Enabling this will increase the precision of the shortened threat totals to 3 decimal places.  When disabled, only 1 decimal place will be used.",
						Events = {
							ButtonCheck = "OnThreatTotalPrecision",
							ButtonUncheck = "OnThreatTotalPrecision",
						},
					},
          {
            AnchorOffsets = { 10, 145, 0, 170 },
            AnchorPoints = "HFILL",
            Class = "Button",
            Base = "BK3:btnHolo_Check",
            Font = "CRB_InterfaceMedium",
            ButtonType = "Check",
            DT_VCENTER = true,
            Name = "LockWindow",
            TextColor = "UI_WindowTextDefault",
            NormalTextColor = "UI_BtnTextBlueNormal",
            PressedTextColor = "UI_BtnTextBluePressed",
            FlybyTextColor = "UI_BtnTextBlueFlyby",
            PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
            DisabledTextColor = "UI_BtnTextBlueDisabled",
            Text = "Lock Threat Meter",
            DrawAsCheckbox = true,
            Tooltip = "Enabling this will increase the precision of the shortened threat totals to 3 decimal places.  When disabled, only 1 decimal place will be used.",
            Events = {
              ButtonCheck = "OnMainWindowLock",
              ButtonUncheck = "OnMainWindowLock",
            },
          },

                    {
            AnchorOffsets = { -350, 175, -25, 215 },
            AnchorPoints = "TOPRIGHT",
            RelativeToClient = true,
            Name = "MainWindowOpacitySliderFrame",
            IgnoreMouse = true,
            Children = {
              {
                AnchorOffsets = { 0, 7, 0, 27 },
                AnchorPoints = "HFILL",
                Class = "SliderBar",
                RelativeToClient = true,
                Template = "CRB_Scroll_HoloLarge",
                Name = "MainWindowOpacitySlider",
                DiscreteTicks = false,
                UseButtons = true,
                Min = 0.000000,
                Max = 100.000000,
                TickAmount = 1.000000,
                Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo",
                Events = {
                  SliderBarChanged = "OnMainWindowOpacitySliderBarChanged",
                },
              },
              {
                AnchorOffsets = { -46, 3, -4, -2 },
                AnchorPoints = "VFILL",
                RelativeToClient = true,
                Font = "CRB_InterfaceMedium",
                Text = 8888,
                Template = "CRB_NormalFramedThin",
                Name = "MainWindowOpacityEditBox",
                TextColor = "UI_WindowTextDefault",
                NoClip = true,
                DT_RIGHT = true,
                DT_VCENTER = true,
              },
            },
          },

          {
            AnchorOffsets = { -350, 215, -25, 245 },
            AnchorPoints = "TOPRIGHT",
            RelativeToClient = true,
            Name = "ArtWorkOpacitySliderFrame",
            IgnoreMouse = true,
            Children = {
              {
                AnchorOffsets = { 0, 7, 0, 27 },
                AnchorPoints = "HFILL",
                Class = "SliderBar",
                RelativeToClient = true,
                Template = "CRB_Scroll_HoloLarge",
                Name = "ArtWorkOpacitySlider",
                DiscreteTicks = false,
                UseButtons = true,
                Min = 0.000000,
                Max = 100.000000,
                TickAmount = 1.000000,
                Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo",
                Events = {
                  SliderBarChanged = "OnArtWorkOpacitySliderBarChanged",
                },
              },
              {
                AnchorOffsets = { -46, 3, -4, -2 },
                AnchorPoints = "VFILL",
                RelativeToClient = true,
                Font = "CRB_InterfaceMedium",
                Text = 8888,
                Template = "CRB_NormalFramedThin",
                Name = "ArtWorkOpacityEditBox",
                TextColor = "UI_WindowTextDefault",
                NoClip = true,
                DT_RIGHT = true,
                DT_VCENTER = true,
              },
            },
          },

          {
            AnchorOffsets = { 0, 0, 0, -25 },
            AnchorPoints = "FILL",
            RelativeToClient = true,
            Name = "BG_ShowWhen",
            Sprite = "BK3:UI_BK3_Holo_InsetSimple",
            Picture = true,
            IgnoreMouse = true,
          },

          {
            AnchorOffsets = { 141, 8, -10, 39 },
            AnchorPoints = "HFILL",
            RelativeToClient = true,
            Name = "TPSSliderFrame",
            IgnoreMouse = true,
            Children = {
              {
                AnchorOffsets = { 0, 6, 0, 26 },
                AnchorPoints = "HFILL",
                Class = "SliderBar",
                RelativeToClient = true,
                Template = "CRB_Scroll_HoloLarge",
                Name = "TPSSlider",
                DiscreteTicks = false,
                UseButtons = true,
                Min = 3.000000,
                Max = 15.000000,
                TickAmount = 1.000000,
                Tooltip = "The threat per second calculation is based on a real time sliding window of the last X seconds.",
                Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo",
                Events = {
                  SliderBarChanged = "OnTPSSliderBarChanged",
                },
              },
              {
                AnchorOffsets = { -46, 3, -4, -2 },
                AnchorPoints = "VFILL",
                RelativeToClient = true,
                Font = "CRB_InterfaceMedium",
                Text = 8888,
                Template = "CRB_NormalFramedThin",
                Name = "TPSEditBox",
                TextColor = "UI_WindowTextDefault",
                NoClip = true,
                DT_RIGHT = true,
                DT_VCENTER = true,
              },
            },
          },
          {
            AnchorOffsets = { 9, 40, -9, 110 },
            AnchorPoints = "HFILL",
            RelativeToClient = true,
            BGColor = "UI_WindowBGDefault",
            TextColor = "UI_WindowTextDefault",
            Name = "BarColorFrame",
            Children = {
              {
                AnchorOffsets = { 3, 10, 27, 34 },
                RelativeToClient = true,
                BGColor = "xkcdLavender",
                TextColor = "UI_WindowTextDefault",
                Name = "PlayerBarColor",
                Sprite = "BasicSprites:WhiteFill",
                Picture = true,
                IgnoreMouse = true,
                Children = {
                  {
                    AnchorOffsets = { -6, -6, 6, 6 },
                    AnchorPoints = "FILL",
                    Class = "Button",
                    Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue",
                    Font = "DefaultButton",
                    ButtonType = "PushButton",
                    DT_VCENTER = true,
                    DT_CENTER = true,
                    BGColor = "UI_BtnBGDefault",
                    TextColor = "UI_BtnTextDefault",
                    NormalTextColor = "UI_BtnTextDefault",
                    PressedTextColor = "UI_BtnTextDefault",
                    FlybyTextColor = "UI_BtnTextDefault",
                    PressedFlybyTextColor = "UI_BtnTextDefault",
                    DisabledTextColor = "UI_BtnTextDefault",
                    Name = "PlayerBarColorBtn",
                    NoClip = true,
                    Events = {
                      ButtonSignal = function(self, wndHandler, wndControl)
                        self.DaiColorPicker.AdjustColor(self.db.crPlayer, function(newColor, bIsFinal)
                          if not bIsFinal then return end
                          self.db.crPlayer = newColor
                          wndControl:GetParent():SetBGColor(newColor)
                        end)
                      end,
                    },
                  },
                  {
                    AnchorOffsets = { 33, 0, 131, 0 },
                    AnchorPoints = "VFILL",
                    RelativeToClient = true,
                    Font = "CRB_InterfaceMedium",
                    BGColor = "UI_WindowBGDefault",
                    TextColor = "UI_WindowTextDefault",
                    Name = "Label",
                    TextId = "Achievement_PlayerBtn",
                    IgnoreMouse = true,
                    NoClip = true,
                    DT_VCENTER = true,
                  },
                },
              },
              {
                AnchorOffsets = { 203, 10, 227, 34 },
                RelativeToClient = true,
                BGColor = "xkcdLightIndigo",
                TextColor = "UI_WindowTextDefault",
                Name = "PlayerPetBarColor",
                Sprite = "BasicSprites:WhiteFill",
                Picture = true,
                IgnoreMouse = true,
                Children = {
                  {
                    AnchorOffsets = { -6, -6, 6, 6 },
                    AnchorPoints = "FILL",
                    Class = "Button",
                    Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue",
                    Font = "DefaultButton",
                    ButtonType = "PushButton",
                    DT_VCENTER = true,
                    DT_CENTER = true,
                    BGColor = "UI_BtnBGDefault",
                    TextColor = "UI_BtnTextDefault",
                    NormalTextColor = "UI_BtnTextDefault",
                    PressedTextColor = "UI_BtnTextDefault",
                    FlybyTextColor = "UI_BtnTextDefault",
                    PressedFlybyTextColor = "UI_BtnTextDefault",
                    DisabledTextColor = "UI_BtnTextDefault",
                    Name = "PlayerPetBarColorBtn",
                    NoClip = true,
                    Events = {
                      ButtonSignal = function(self, wndHandler, wndControl)
                        self.DaiColorPicker.AdjustColor(self.db.crPlayerPet, function(newColor, bIsFinal)
                          if not bIsFinal then return end
                          self.db.crPlayerPet = newColor
                          wndControl:GetParent():SetBGColor(newColor)
                        end)
                      end,
                    },
                  },
                  {
                    AnchorOffsets = { 33, 0, 131, 0 },
                    AnchorPoints = "VFILL",
                    RelativeToClient = true,
                    Font = "CRB_InterfaceMedium",
                    Text = "Player Pet",
                    BGColor = "UI_WindowBGDefault",
                    TextColor = "UI_WindowTextDefault",
                    Name = "Label",
                    IgnoreMouse = true,
                    NoClip = true,
                    DT_VCENTER = true,
                  },
                },
              },
              {
                AnchorOffsets = { 3, 42, 27, 66 },
                RelativeToClient = true,
                BGColor = "xkcdLightForestGreen",
                TextColor = "UI_WindowTextDefault",
                Name = "GroupMemberBarColor",
                Sprite = "BasicSprites:WhiteFill",
                Picture = true,
                IgnoreMouse = true,
                Children = {
                  {
                    AnchorOffsets = { -6, -6, 6, 6 },
                    AnchorPoints = "FILL",
                    Class = "Button",
                    Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue",
                    Font = "DefaultButton",
                    ButtonType = "PushButton",
                    DT_VCENTER = true,
                    DT_CENTER = true,
                    BGColor = "UI_BtnBGDefault",
                    TextColor = "UI_BtnTextDefault",
                    NormalTextColor = "UI_BtnTextDefault",
                    PressedTextColor = "UI_BtnTextDefault",
                    FlybyTextColor = "UI_BtnTextDefault",
                    PressedFlybyTextColor = "UI_BtnTextDefault",
                    DisabledTextColor = "UI_BtnTextDefault",
                    Name = "GroupMemberBarColorBtn",
                    NoClip = true,
                    Events = {
                      ButtonSignal = function(self, wndHandler, wndControl)
                        self.DaiColorPicker.AdjustColor(self.db.crGroupMember, function(newColor, bIsFinal)
                          if not bIsFinal then return end
                          self.db.crGroupMember = newColor
                          wndControl:GetParent():SetBGColor(newColor)
                        end)
                      end,
                    },
                  },
                  {
                    AnchorOffsets = { 33, 0, 131, 0 },
                    AnchorPoints = "VFILL",
                    RelativeToClient = true,
                    Font = "CRB_InterfaceMedium",
                    Text = "Group Member",
                    BGColor = "UI_WindowBGDefault",
                    TextColor = "UI_WindowTextDefault",
                    Name = "Label",
                    IgnoreMouse = true,
                    NoClip = true,
                    DT_VCENTER = true,
                  },
                },
              },
              {
                AnchorOffsets = { 204, 41, 228, 65 },
                RelativeToClient = true,
                BGColor = "xkcdScarlet",
                TextColor = "UI_WindowTextDefault",
                Name = "NotPlayerBarColor",
                Sprite = "BasicSprites:WhiteFill",
                Picture = true,
                IgnoreMouse = true,
                Children = {
                  {
                    AnchorOffsets = { -6, -6, 6, 6 },
                    AnchorPoints = "FILL",
                    Class = "Button",
                    Base = "CRB_CraftingCircuitSprites:btnCircuit_SquareGlass_Blue",
                    Font = "DefaultButton",
                    ButtonType = "PushButton",
                    DT_VCENTER = true,
                    DT_CENTER = true,
                    BGColor = "UI_BtnBGDefault",
                    TextColor = "UI_BtnTextDefault",
                    NormalTextColor = "UI_BtnTextDefault",
                    PressedTextColor = "UI_BtnTextDefault",
                    FlybyTextColor = "UI_BtnTextDefault",
                    PressedFlybyTextColor = "UI_BtnTextDefault",
                    DisabledTextColor = "UI_BtnTextDefault",
                    Name = "NotPlayerBarColorBtn",
                    NoClip = true,
                    Events = {
                      ButtonSignal = function(self, wndHandler, wndControl)
                        self.DaiColorPicker.AdjustColor(self.db.crNotPlayer, function(newColor, bIsFinal)
                          if not bIsFinal then return end
                          self.db.crNotPlayer = newColor
                          wndControl:GetParent():SetBGColor(newColor)
                        end)
                      end,
                    },
                  },
                  {
                    AnchorOffsets = { 33, 0, 131, 0 },
                    AnchorPoints = "VFILL",
                    RelativeToClient = true,
                    Font = "CRB_InterfaceMedium",
                    Text = "Everyone Else",
                    BGColor = "UI_WindowBGDefault",
                    TextColor = "UI_WindowTextDefault",
                    Name = "Label",
                    IgnoreMouse = true,
                    NoClip = true,
                    DT_VCENTER = true,
                  },
                },
              },
            },
          },
        },
      },
      {
        AnchorOffsets = { 0, 39, 0, 64 },
        AnchorPoints = "HFILL",
        Font = "CRB_InterfaceLarge",
        Text = "ThreatMeter Options",
        Template = "CRB_NormalFramedThin",
        Name = "ThreatMeterTitle",
        TextColor = "UI_TextHoloTitle",
        DT_CENTER = true,
        DT_VCENTER = true,
        IgnoreMouse = true,
      },
      {
        AnchorOffsets = { 0, 310, 0, 500 },
        AnchorPoints = "HFILL",
        RelativeToClient = true,
        Name = "ShowHideFrame",
        Children =
        {
          {
            AnchorOffsets = { 58, 0, -19, 25 },
            AnchorPoints = { 0, 0, 0.5, 0 },
            Font = "CRB_InterfaceLarge",
            Text = "Show when...",
            Template = "CRB_NormalFramedThin",
            Name = "ShowWhenTitle",
            TextColor = "UI_TextHoloTitle",
            DT_CENTER = true,
            DT_VCENTER = true,
            IgnoreMouse = true,
          },
          {
            AnchorOffsets = { -17, 0, -58, 25 },
            AnchorPoints = { 0.5, 0, 1, 0 },
            Font = "CRB_InterfaceLarge",
            Text = "However, hide if...",
            Template = "CRB_NormalFramedThin",
            Name = "HideWhenTitle",
            TextColor = "UI_TextHoloTitle",
            DT_CENTER = true,
            DT_VCENTER = true,
            IgnoreMouse = true,
            Tooltip = "However, hide Threat Meter if any of the following are true (higher priority than the Show When... options)",
          },
          {
            AnchorOffsets = { -16, 27, -60, -25 },
            AnchorPoints = { 0.5, 0, 1, 1 },
            RelativeToClient = true,
            Template = "CRB_InnerWindow",
            Name = "HideWhenFrame",
            NewControlDepth = 10,
            IgnoreMouse = true,
            Children = {
              {
                AnchorPoints = "FILL",
                RelativeToClient = true,
                Name = "BG_HideWhen",
                Sprite = "BK3:UI_BK3_Holo_InsetSimple",
                Picture = true,
                IgnoreMouse = true,
              },
              {
                AnchorOffsets = { 10, 79, 0, 103 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "HideWhenInPvP",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " You are in instanced PvP",
                DrawAsCheckbox = true,
                Tooltip = "Enabling this will hide Threat Meter when you are in a battleground, arena or warplot",
                Events = {
                  ButtonCheck = "OnHideWhenInInstancedPvP",
                  ButtonUncheck = "OnHideWhenInInstancedPvP",
                },
              },
              {
                AnchorOffsets = { 10, 19, 0, 43 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "HideWhenNotInCombat",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " Not In Combat: Meter",
                DrawAsCheckbox = true,
                Tooltip = "Enabling this will hide Threat Meter when you are not in combat",
                Events = {
                  ButtonCheck = "OnHideWhenNotInCombat",
                  ButtonUncheck = "OnHideWhenNotInCombat",
                },
              },
                {
                  AnchorOffsets = { 10, 49, 0, 73 },
                  AnchorPoints = "HFILL",
                  Class = "Button",
                  Base = "BK3:btnHolo_Check",
                  Font = "CRB_InterfaceMedium",
                  ButtonType = "Check",
                  DT_VCENTER = true,
                  Name = "HideWarningWhenNotInCombat",
                  TextColor = "UI_WindowTextDefault",
                  NormalTextColor = "UI_BtnTextBlueNormal",
                  PressedTextColor = "UI_BtnTextBluePressed",
                  FlybyTextColor = "UI_BtnTextBlueFlyby",
                  PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                  DisabledTextColor = "UI_BtnTextBlueDisabled",
                  Text = " Not In Combat: Warning",
                  DrawAsCheckbox = true,
                  Tooltip = "Enabling this will hide Threat Meter Warning when you are not in combat",
                  Events = {
                    ButtonCheck = "OnHideWarningWhenNotInCombat",
                    ButtonUncheck = "OnHideWarningWhenNotInCombat",
                  },
                },
              },
          },
          {
            AnchorOffsets = { 60, 27, -20, -25 },
            AnchorPoints = { 0, 0, 0.5, 1 },
            RelativeToClient = true,
            Template = "CRB_InnerWindow",
            Name = "ShowWhenFrame",
            NewControlDepth = 10,
            IgnoreMouse = true,
            Children = {
              {
                AnchorPoints = "FILL",
                RelativeToClient = true,
                Name = "BG_ShowWhen",
                Sprite = "BK3:UI_BK3_Holo_InsetSimple",
                Picture = true,
                IgnoreMouse = true,
              },
              {
                AnchorOffsets = { 10, 79, 0, 103 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "ShowWhenInGroup",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " You are in a group",
                DrawAsCheckbox = true,
                Tooltip = "Show Threat Meter when you are in a 5-man group",
                Events = {
                  ButtonCheck = "OnShowWhenInGroup",
                  ButtonUncheck = "OnShowWhenInGroup",
                },
              },
              {
                AnchorOffsets = { 10, 19, 0, 43 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "ShowWhenHavePet",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " You have a pet",
                DrawAsCheckbox = true,
                Tooltip = "Show Threat Meter when you have a pet out",
                Events = {
                  ButtonCheck = "OnShowWhenHavePet",
                  ButtonUncheck = "OnShowWhenHavePet",
                },
              },
              {
                AnchorOffsets = { 10, 49, 0, 73 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "ShowWhenAlone",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " You are alone",
                DrawAsCheckbox = true,
                Tooltip = "Show Threat Meter when you are alone",
                Events = {
                  ButtonCheck = "OnShowWhenAlone",
                  ButtonUncheck = "OnShowWhenAlone",
                },
              },
              {
                AnchorOffsets = { 10, 109, 0, 133 },
                AnchorPoints = "HFILL",
                Class = "Button",
                Base = "BK3:btnHolo_Check",
                Font = "CRB_InterfaceMedium",
                ButtonType = "Check",
                DT_VCENTER = true,
                Name = "ShowWhenInRaid",
                TextColor = "UI_WindowTextDefault",
                NormalTextColor = "UI_BtnTextBlueNormal",
                PressedTextColor = "UI_BtnTextBluePressed",
                FlybyTextColor = "UI_BtnTextBlueFlyby",
                PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
                DisabledTextColor = "UI_BtnTextBlueDisabled",
                Text = " You are in a raid",
                DrawAsCheckbox = true,
                Tooltip = "Show Threat Meter when you are in a raid",
                Events = {
                  ButtonCheck = "OnShowWhenInRaid",
                  ButtonUncheck = "OnShowWhenInRaid",
                },
              },
            },
          },
        },
      },
      {
        AnchorOffsets = { 0, 470, 0, 700 },
        AnchorPoints = "HFILL",
        RelativeToClient = true,
        Name = "WarningsFrame",
        Pixies = {
          { AnchorOffsets = { 75, 100, 508, 110 }, BGColor = "white", TextColor = "UI_TextHoloBodyHighlight", Font = "CRB_Interface10", Text = "Warning Threshold %", DT_VCENTER = true, },
          { AnchorOffsets = { 75, 146, 508, 156 }, BGColor = "white", TextColor = "UI_TextHoloBodyHighlight", Font = "CRB_Interface10", Text = "Warning Opacity %", DT_VCENTER = true, },
        },
        Children =
        {
          {
            AnchorOffsets = { 60, 27, -60, -25 },
            AnchorPoints = "FILL",
            RelativeToClient = true,
            Name = "BG_Warnings",
            Sprite = "BK3:UI_BK3_Holo_InsetSimple",
            Picture = true,
            IgnoreMouse = true,
          },
          {
            AnchorOffsets = { 60, -15, -60, 0 },
            AnchorPoints = "HFILLBOTTOM",
            RelativeToClient = true,
            Name = "BG_WarningsDivider",
            Sprite = "BK3:UI_BK3_Holo_InsetDividerStripe",
            Picture = true,
            IgnoreMouse = true,
            Visible = false,
          },
          {
            AnchorOffsets = { 0, 0, 0, 25 },
            AnchorPoints = "HFILL",
            Font = "CRB_InterfaceLarge",
            Text = "Warning Settings",
            Template = "CRB_NormalFramedThin",
            Name = "WarningsTitle",
            TextColor = "UI_TextHoloTitle",
            DT_CENTER = true,
            DT_VCENTER = true,
            IgnoreMouse = true,
          },
          {
            AnchorOffsets = { 70, 46, 270, 70 },
            Class = "Button",
            Base = "BK3:btnHolo_Check",
            Font = "CRB_InterfaceMedium",
            ButtonType = "Check",
            DT_VCENTER = true,
            Name = "WarningTankDisable",
            TextColor = "UI_BtnTextDefault",
            NormalTextColor = "UI_BtnTextBlueNormal",
            PressedTextColor = "UI_BtnTextBluePressed",
            FlybyTextColor = "UI_BtnTextBlueFlyby",
            PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
            DisabledTextColor = "UI_BtnTextBlueDisabled",
            Text = " Disable While Tanking",
            DrawAsCheckbox = true,
            Tooltip = "Do not give out any warnings when a tanking stance is active",
            UseWindowTextColor = false,
            Events = {
              ButtonCheck = "OnWarningTankDisable",
              ButtonUncheck = "OnWarningTankDisable",
            },
          },
          {
            AnchorOffsets = { 70, 76, 270, 100 },
            Class = "Button",
            Base = "BK3:btnHolo_Check",
            Font = "CRB_InterfaceMedium",
            ButtonType = "Check",
            DT_VCENTER = true,
            Name = "WarningUseSound",
            TextColor = "UI_WindowTextDefault",
            NormalTextColor = "UI_BtnTextBlueNormal",
            PressedTextColor = "UI_BtnTextBluePressed",
            FlybyTextColor = "UI_BtnTextBlueFlyby",
            PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
            DisabledTextColor = "UI_BtnTextBlueDisabled",
            Text = " Enable Sound",
            DrawAsCheckbox = true,
            Tooltip = "Play a sound effect when you accumulate too much threat",
            Events = {
              ButtonCheck = "OnWarningUseSound",
              ButtonUncheck = "OnWarningUseSound",
            },
          },
          {
            AnchorOffsets = { 250, 46, 440, 70 },
            Class = "Button",
            Base = "BK3:btnHolo_Check",
            Font = "CRB_InterfaceMedium",
            ButtonType = "Check",
            DT_VCENTER = true,
            Name = "WarningUseMessage",
            TextColor = "UI_WindowTextDefault",
            NormalTextColor = "UI_BtnTextBlueNormal",
            PressedTextColor = "UI_BtnTextBluePressed",
            FlybyTextColor = "UI_BtnTextBlueFlyby",
            PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
            DisabledTextColor = "UI_BtnTextBlueDisabled",
            Text = " Enable Warning Message",
            DrawAsCheckbox = true,
            Tooltip = "Print a message to screen when you accumulate too much threat",
            Events = {
              ButtonCheck = "OnWarningUseMessage",
              ButtonUncheck = "OnWarningUseMessage",
            },
          },
          {
            AnchorOffsets = { 250, 76, 440, 100 },
            Class = "Button",
            Base = "BK3:btnHolo_Check",
            Font = "CRB_InterfaceMedium",
            ButtonType = "Check",
            DT_VCENTER = true,
            Name = "WarningLock",
            TextColor = "UI_WindowTextDefault",
            NormalTextColor = "UI_BtnTextBlueNormal",
            PressedTextColor = "UI_BtnTextBluePressed",
            FlybyTextColor = "UI_BtnTextBlueFlyby",
            PressedFlybyTextColor = "UI_BtnTextBluePressedFlyby",
            DisabledTextColor = "UI_BtnTextBlueDisabled",
            Text = "Lock Warning Message",
            DrawAsCheckbox = true,
            Tooltip = "Lock the Warning Message in its current location",
            Events = {
              ButtonCheck = "OnWarningLock",
              ButtonUncheck = "OnWarningLock",
            },
          },

          {
            AnchorOffsets = { -400, 116, -75, 146 },
            AnchorPoints = "TOPRIGHT",
            RelativeToClient = true,
            Name = "WarningThresholdSliderFrame",
            IgnoreMouse = true,
            Children = {
              {
                AnchorOffsets = { 0, 7, 0, 27 },
                AnchorPoints = "HFILL",
                Class = "SliderBar",
                RelativeToClient = true,
                Template = "CRB_Scroll_HoloLarge",
                Name = "WarningThresholdSlider",
                DiscreteTicks = false,
                UseButtons = true,
                Min = 0.000000,
                Max = 100.000000,
                TickAmount = 1.000000,
                Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo",
                Events = {
                  SliderBarChanged = "OnWarningThresholdSliderBarChanged",
                },
              },
              {
                AnchorOffsets = { -46, 3, -4, -2 },
                AnchorPoints = "VFILL",
                RelativeToClient = true,
                Font = "CRB_InterfaceMedium",
                Text = 8888,
                Template = "CRB_NormalFramedThin",
                Name = "WarningThresholdEditBox",
                TextColor = "UI_WindowTextDefault",
                NoClip = true,
                DT_RIGHT = true,
                DT_VCENTER = true,
              },
            },
          },
          {
            AnchorOffsets = { -400, 156, -75, 186 },
            AnchorPoints = "TOPRIGHT",
            RelativeToClient = true,
            Name = "WarningOpacitySliderFrame",
            IgnoreMouse = true,
            Children = {
              {
                AnchorOffsets = { 0, 7, 0, 27 },
                AnchorPoints = "HFILL",
                Class = "SliderBar",
                RelativeToClient = true,
                Template = "CRB_Scroll_HoloLarge",
                Name = "WarningOpacitySlider",
                DiscreteTicks = false,
                UseButtons = true,
                Min = 0.000000,
                Max = 100.000000,
                TickAmount = 1.000000,
                Middle = "CRB_Basekit:kitScrollbase_Horiz_Holo",
                Events = {
                  SliderBarChanged = "OnWarningOpacitySliderBarChanged",
                },
              },
              {
                AnchorOffsets = { -46, 3, -4, -2 },
                AnchorPoints = "VFILL",
                RelativeToClient = true,
                Font = "CRB_InterfaceMedium",
                Text = 8888,
                Template = "CRB_NormalFramedThin",
                Name = "WarningOpacityEditBox",
                TextColor = "UI_WindowTextDefault",
                NoClip = true,
                DT_RIGHT = true,
                DT_VCENTER = true,
              },
            },
          },
        },
      },
    },
  },

}
